<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Louvain Algorithm: src/linkedlist.h File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Louvain Algorithm
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#nested-classes">Data Structures</a> &#124;
<a href="#typedef-members">Typedefs</a> &#124;
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">linkedlist.h File Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><div class="dynheader">
This graph shows which files directly or indirectly include this file:</div>
<div class="dyncontent">
<div class="center"><img src="linkedlist_8h__dep__incl.png" border="0" usemap="#src_2linkedlist_8hdep" alt=""/></div>
<map name="src_2linkedlist_8hdep" id="src_2linkedlist_8hdep">
<area shape="rect" id="node2" href="community_8h.html" title="src/community.h" alt="" coords="103,80,221,107"/>
<area shape="rect" id="node3" href="community_8c.html" title="src/community.c" alt="" coords="5,155,124,181"/>
<area shape="rect" id="node5" href="linkedlist_8c.html" title="src/linkedlist.c" alt="" coords="246,80,353,107"/>
<area shape="rect" id="node4" href="louvain_8c.html" title="src/louvain.c" alt="" coords="149,155,245,181"/>
</map>
</div>
</div>
<p><a href="linkedlist_8h_source.html">Go to the source code of this file.</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Data Structures</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structnode__t.html">node_t</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="typedef-members"></a>
Typedefs</h2></td></tr>
<tr class="memitem:a7856550eaf3d2ba89448e2795b8a744e"><td class="memItemLeft" align="right" valign="top">typedef struct <a class="el" href="structnode__t.html">node_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="linkedlist_8h.html#a7856550eaf3d2ba89448e2795b8a744e">node_t</a></td></tr>
<tr class="separator:a7856550eaf3d2ba89448e2795b8a744e"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:a879c25aae9dec089ed2ad5816e62337a"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="linkedlist_8h.html#a879c25aae9dec089ed2ad5816e62337a">pop</a> (<a class="el" href="structnode__t.html">node_t</a> **head)</td></tr>
<tr class="separator:a879c25aae9dec089ed2ad5816e62337a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad936801435fbad28647733af6d6948b0"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="linkedlist_8h.html#ad936801435fbad28647733af6d6948b0">push</a> (<a class="el" href="structnode__t.html">node_t</a> **head, int val)</td></tr>
<tr class="separator:ad936801435fbad28647733af6d6948b0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac028743b107d5514d55a0c5eeefcce67"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="linkedlist_8h.html#ac028743b107d5514d55a0c5eeefcce67">remove_index</a> (<a class="el" href="structnode__t.html">node_t</a> **head, int id)</td></tr>
<tr class="separator:ac028743b107d5514d55a0c5eeefcce67"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa95fbdd677c712cdafbfed0b4cd9c2f8"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="linkedlist_8h.html#aa95fbdd677c712cdafbfed0b4cd9c2f8">clear</a> (<a class="el" href="structnode__t.html">node_t</a> *head)</td></tr>
<tr class="separator:aa95fbdd677c712cdafbfed0b4cd9c2f8"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Typedef Documentation</h2>
<a id="a7856550eaf3d2ba89448e2795b8a744e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7856550eaf3d2ba89448e2795b8a744e">&#9670;&nbsp;</a></span>node_t</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef struct <a class="el" href="structnode__t.html">node_t</a>  <a class="el" href="structnode__t.html">node_t</a></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<h2 class="groupheader">Function Documentation</h2>
<a id="aa95fbdd677c712cdafbfed0b4cd9c2f8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa95fbdd677c712cdafbfed0b4cd9c2f8">&#9670;&nbsp;</a></span>clear()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void clear </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structnode__t.html">node_t</a> *&#160;</td>
          <td class="paramname"><em>head</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Function to clear the memory allocated for the list. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">head</td><td>The pointer to the list head. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a879c25aae9dec089ed2ad5816e62337a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a879c25aae9dec089ed2ad5816e62337a">&#9670;&nbsp;</a></span>pop()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int pop </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structnode__t.html">node_t</a> **&#160;</td>
          <td class="paramname"><em>head</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Function to remove the head node also freeing its allocated memory. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">head</td><td>A pointer to the pointer of the first node in the list </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>-1 if the list was already empty, THE VALUE CONTAINED IN THE HEAD NODE otherwise. </dd></dl>

</div>
</div>
<a id="ad936801435fbad28647733af6d6948b0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad936801435fbad28647733af6d6948b0">&#9670;&nbsp;</a></span>push()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void push </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structnode__t.html">node_t</a> **&#160;</td>
          <td class="paramname"><em>head</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>val</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Function to put a new head containing the specified value to a given list. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">head</td><td>A pointer to the pointer containing the address of the head of the list. </td></tr>
    <tr><td class="paramname">val</td><td>The value to be assigned to the new head. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ac028743b107d5514d55a0c5eeefcce67"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac028743b107d5514d55a0c5eeefcce67">&#9670;&nbsp;</a></span>remove_index()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int remove_index </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structnode__t.html">node_t</a> **&#160;</td>
          <td class="paramname"><em>head</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>number</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Function to remove a node from the list giving the value contained in it. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">head</td><td>A pointer to the pointer containing the address of the head of the list. </td></tr>
    <tr><td class="paramname">number</td><td>The value contained in the node to be removed. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>-1 if the removal failed, 0 if the node was in the head, 1 if it was anywhere else. </dd></dl>

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
